
#include "vfuncs.h"

// baseentity
int m_Off_GetDataDescMap;


// vfuncs
class VEmptyClass {};
datamap_t *VGetDataDescMap(CBaseEntity *pThisPtr)
{
	void **this_ptr = *reinterpret_cast<void ***>(&pThisPtr);
	void **vtable = *reinterpret_cast<void ***>(pThisPtr);
	void *vfunc = vtable[m_Off_GetDataDescMap];

	union
	{
		datamap_t *(VEmptyClass::*mfpnew)();
#ifndef PLATFORM_POSIX
		void *addr;
	} u;
	u.addr = vfunc;
#else
		struct  
		{
			void *addr;
			intptr_t adjustor;
		} s;
	} u;
	u.s.addr = vfunc;
	u.s.adjustor = 0;
#endif

	return (datamap_t *)(reinterpret_cast<VEmptyClass *>(this_ptr)->*u.mfpnew)();
}



// functions

bool InitializeVFuncs( IGameConfig *GameConf )
{
	GameConf->GetOffset("GetDataDescMap", &m_Off_GetDataDescMap);
	if (m_Off_GetDataDescMap<1) return false;

	return true;
}



// util functions

int FindOffsetDMap(datamap_t *dmap, const char *property)
{
	int ret = 0;
	int oldoffset = 0;
	static int offset = 0;

	while (dmap)
	{
		for ( int i = 0; i < dmap->dataNumFields; i++ )
		{

			if (dmap->dataDesc[i].fieldName)
			{
				if (FStrEq(dmap->dataDesc[i].fieldName, property))
				{
					return dmap->dataDesc[i].fieldOffset[0] + offset;
				}
			}

			if (dmap->dataDesc[i].td)
			{
				datamap_t *dmap2 = dmap->dataDesc[i].td;
				oldoffset = offset;
				offset = dmap->dataDesc[i].fieldOffset[0];
				ret = FindOffsetDMap(dmap2, property);
				offset = oldoffset;
				if (ret > 0)
				{
					return ret;
				}
			}
		}
		dmap = dmap->baseMap; 
	}

	return 0;
}

